
--
--  Foo.lua : example of plugin
--
--      $ export LUA_PATH="$LUA_PATH;./eg/?.lua"
--      $ smc -load Foo file.sm
--

require 'Coat'
local CodeGen = require 'CodeGen'

singleton 'Foo'
extends 'Smc.Language'

has.id              = { '+', default = 'FOO' }
has.name            = { '+', default = 'Foo' }
has.option          = { '+', default = '-foo' }
has.suffix          = { '+', default = '_sm' }
has.generator       = { '+', isa = 'Foo.Generator',
                        default = function () return require 'Foo.Generator' end }


class 'Foo.Generator'
extends 'Smc.Generator'

has.suffix          = { '+', default = 'foo' }

function method:_build_template ()
    return CodeGen{
        TOP = [[
//
// generated by smc (http://github.com/fperrad/lua-Smc) with the plugin Foo.lua
// from file : ${fsm.filename}

FOO
]],
    }
end

